---
title: Navigation and resource timings
slug: Web/Performance/Navigation_and_resource_timings
tags:
  - Navigation Timing
  - Resource Timing
  - Timings
  - Web Performance
  - performance APIs
---
<p><span class="seoSummary"><strong>Navigation timings </strong>are metrics measuring a browser's document navigation events. <strong>Resource timings </strong>are detailed network timing measurements regarding the loading of an application's resources.</span> Both provide the same read-only properties, but navigation timing measures the main document's timings whereas the resource timing provides the times for all the assets or resources called in by that main document and the resources' requested resources.</p>

<p>The general performance timings below have been deprecated in favor of the Performance Entry API, which provides for marking and measuring times along the navigation and resource loading process. While deprecated, they are supported in all browsers.</p>

<h2 id="Performance_Timings">Performance Timings</h2>

<p>The <a href="/en-US/docs/Web/API/PerformanceTiming">performanceTiming API</a>, a JavaScript API for measuring the loading performance of the requested page, is deprecated but supported in all browsers. It has been replaced with the <a href="/en-US/docs/Web/API/PerformanceNavigationTiming">performanceNavigationTiming</a> API.</p>

<p>The performance timing API provided read only times, in milliseconds(ms), describing at what time each point in the page loading process was reached. As displayed in the image below, the navigation process goes from <code><a href="/en-US/docs/Web/API/PerformanceTiming/navigationStart">navigationStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/unloadEventStart">unloadEventStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/unloadEventEnd">unloadEventEnd</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/redirectStart">redirectStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/redirectEnd">redirectEnd</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/fetchStart">fetchStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domainLookupStart">domainLookupStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domainLookupEnd">domainLookupEnd</a></code>, <a href="/en-US/docs/Web/API/PerformanceTiming/connectStart">c<code>onnectStart</code></a> , <code><a href="/en-US/docs/Web/API/PerformanceTiming/connectEnd">connectEnd</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/secureConnectionStart">secureConnectionStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/requestStart">requestStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/responseStart">responseStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/responseEnd">responseEnd</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domLoading">domLoading</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domInteractive">domInteractive</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domContentLoadedEventStart">domContentLoadedEventStart</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domContentLoadedEventEnd">domContentLoadedEventEnd</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/domComplete">domComplete</a></code>, <code><a href="/en-US/docs/Web/API/PerformanceTiming/loadEventStart">loadEventStart</a></code>, and <code><a href="/en-US/docs/Web/API/PerformanceTiming/loadEventEnd">loadEventEnd</a></code>.</p>

<p><img alt="Navigation Timing event metrics" src="https://mdn.mozillademos.org/files/16620/Screen_Shot_2019-05-03_at_1.06.27_PM.png"></p>

<p>With the metrics above, and a little bit of math, we can calculate many important metrics like <a href="/en-US/docs/Glossary/time_to_first_byte">time to first byte</a>, page load time, dns lookup, and whether the connection is secure.</p>

<p>To help measure the time it takes to complete all the steps, the Performance Timing API  provides read only measurements of navigation timings. To view and capture our app's timing we enter:</p>

<pre>let time = window.performance.timing</pre>

<p>We can then use the results to measure how well our app is performing.</p>

<p><img alt="entering window.performance.timing in the console lists all the timings in the PerformanceNavigationTiming interface" src="https://mdn.mozillademos.org/files/16824/navigatortiming.png"></p>

<p>The order is:</p>

<table>
 <thead>
  <tr>
   <th>Performance Timings</th>
   <th>Details</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{domxref("PerformanceTiming.navigationStart","navigationStart")}}</td>
   <td>When the prompt for unload terminates on the previous document in the same browsing context. If there is no previous document, this value will be the same as <code>PerformanceTiming.fetchStart</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.secureConnectionStart","secureConnectionStart")}}</td>
   <td>When the secure connection handshake starts. If no such connection is requested, it returns <code>0</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.redirectStart","redirectStart")}}</td>
   <td>When the first HTTP redirect starts. If there is no redirect, or if one of the redirects is not of the same origin, the value returned is <code>0</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.redirectEnd","redirectEnd")}}</td>
   <td>
    <p>When the last HTTP redirect is completed, that is when the last byte of the HTTP response has been received. If there is no redirect, or if one of the redirects is not of the same origin, the value returned is <code>0</code>.</p>
   </td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.connectEnd","connectEnd")}}</td>
   <td>When the connection is opened network. If the transport layer reports an error and the connection establishment is started again, the last connection establishment end time is given. If a persistent connection is used, the value will be the same as <code>PerformanceTiming.fetchStart</code>. A connection is considered as opened when all secure connection handshake, or SOCKS authentication, is terminated.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.connectStart","connectStart")}}</td>
   <td>When the request to open a connection is sent to the network. If the transport layer reports an error and the connection establishment is started again, the last connection establishment start time is given. If a persistent connection is used, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domainLookupEnd","domainLookupEnd")}}</td>
   <td>When the domain lookup is finished. If a persistent connection is used, or the information is stored in a cache or a local resource, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domainLookupStart","domainLookupStart")}}</td>
   <td>When the domain lookup starts. If a persistent connection is used, or the information is stored in a cache or a local resource, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.fetchStart","fetchStart")}}</td>
   <td>When the browser is ready to fetch the document using an HTTP request. This moment is <em>before</em> the check to any application cache.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.requestStart","requestStart")}}</td>
   <td>When the browser sent the request to obtain the actual document, from the server or from a cache. If the transport layer fails after the start of the request and the connection is reopened, this property will be set to the time corresponding to the new request.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.responseStart","responseStart")}}</td>
   <td>When the browser received the first byte of the response, from the server from a cache, or from a local resource.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.responseEnd","responseEnd")}}</td>
   <td>When the browser received the last byte of the response, or when the connection is closed if this happened first, from the server, the cache, or from a local resource.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domLoading","domLoading")}}</td>
   <td>When the parser started its work, that is when its {{domxref('Document.readyState')}} changes to <code>'loading'</code> and the corresponding {{DOMxRef("Document.readystatechange_event", "readystatechange")}} event is thrown.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.unloadEventStart","unloadEventStart")}}</td>
   <td>When the {{DOMxRef("Window.unload_event", "unload")}}&gt; event has been thrown, indicating the time at which the previous document in the window began to unload. If there is no previous document, or if the previous document or one of the needed redirects is not of the same origin, the value returned is <code>0</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.unloadEventEnd","unloadEventEnd")}}</td>
   <td>When the <code><a href="/en-US/docs/Web/Events/unload">unload</a></code> event handler finishes. If there is no previous document, or if the previous document, or one of the needed redirects, is not of the same origin, the value returned is <code>0</code>.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domInteractive","domInteractive")}}</td>
   <td>When the parser finished its work on the main document, that is when its <a href="/en-US/docs/Web/API/Document/readyState"><code>Document.readyState</code></a> changes to <code>'interactive'</code> and the corresponding <code><a href="/en-US/docs/Web/Events/readystatechange">readystatechange</a></code> event is thrown.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domContentLoadedEventStart","domContentLoadedEventStart")}}</td>
   <td>Right before the parser sent the <code><a href="/en-US/docs/Web/Events/DOMContentLoaded">DOMContentLoaded</a></code> event, that is right after all the scripts that need to be executed right after parsing have been executed.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domContentLoadedEventEnd","domContentLoadedEventEnd")}}</td>
   <td>Right after all the scripts that need to be executed as soon as possible, in order or not, have been executed.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.domComplete","domComplete")}}</td>
   <td>When the parser finished its work on the main document, that is when its <a href="/en-US/docs/Web/API/Document/readyState"><code>Document.readyState</code></a> changes to <code>'complete'</code> and the corresponding <code><a href="/en-US/docs/Web/Events/readystatechange">readystatechange</a></code> event is thrown.</td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.loadEventStart","loadEventStart")}}</td>
   <td>When the <code><a href="/en-US/docs/Web/Events/load">load</a></code> event was sent for the current document. If this event has not yet been sent, it returns <code>0.</code></td>
  </tr>
  <tr>
   <td>{{domxref("PerformanceTiming.loadEventEnd","loadEventEnd")}}</td>
   <td>When the <code><a href="/en-US/docs/Web/Events/load">load</a></code> event handler terminated, that is when the load event is completed. If this event has not yet been sent, or is not yet completed, it returns <code>0.</code></td>
  </tr>
 </tbody>
</table>

<h3 id="Calculating_timings">Calculating timings</h3>

<p>We can use these values to measure specific timings of interest:</p>

<pre class="brush: js">let
    dns  = time.domainLookupEnd - time.domainLookupStart,
    tcp  = time.connectEnd - time.connectStart,
    ssl != time.<code>secureConnectionStart</code>,</pre>

<h3 id="Time_to_first_byte">Time to first byte</h3>

<p><a href="/en-US/docs/Glossary/time_to_first_byte">Time to First Byte</a> is the time between the <code>navigationStart</code> (start of the navigation) and <code>responseStart</code>, (when the first byte of response data is received) available in the <code>performanceTiming</code> API:</p>

<pre class="brush: js">let ttfb = time.responseStart - time.navigationStart;
</pre>

<h3 id="Page_load_time">Page load time</h3>

<p><a href="/en-US/docs/Glossary/Page_load_time">Page load time</a> is the time between <code>navigationStart</code> and the start of when the load event is sent for the current document. They are only available in the performanceTiming API.</p>

<pre class="brush: js">let pageloadtime = time.loadEventStart - time.navigationStart;</pre>

<h3 id="DNS_lookup_time">DNS lookup time</h3>

<p>The DNS lookup time is the time between <code><a href="/en-US/docs/Web/API/PerformanceResourceTiming/domainLookupStart">domainLookupStart</a></code> and <code><a href="/en-US/docs/Web/API/PerformanceResourceTiming/domainLookupEnd">domainLookupEnd</a></code>. These are both available in both the <code>performanceTiming</code> and <code>performanceNavigationTiming</code> APIs.</p>

<pre class="brush: js">let dns  = time.domainLookupEnd - time.domainLookupStart;</pre>

<h3 id="TCP">TCP</h3>

<p>The time it takes for the <a href="/en-US/docs/Glossary/TCP">TCP</a> handshake is the time between the connection start and connection end:</p>

<pre class="brush: js">tcp  = time.connectEnd - time.connectStart;</pre>

<h3 id="SSL_negotiation">SSL negotiation</h3>

<p><code><a href="/en-US/docs/Web/API/PerformanceResourceTiming/secureConnectionStart">secureConnectionStart</a></code> will be <code>undefined</code> if not available, <code>0</code> if <a href="/en-US/docs/Glossary/https">https</a> in not used, or a time stamp if available, and used. In other words, if a secure connection was used, <code>secureConnectionStart</code> will be <a href="/en-US/docs/Glossary/Truthy">truthy</a>, and the time between <code>secureConnectionStart</code> and <code>requestStart</code> will greater than 0.</p>

<pre class="brush: js">ssl = time.requestStart - time.<code>secureConnectionStart;</code></pre>

<h2 id="Performance_Entry_API">Performance Entry API</h2>

<p>The general performance timings above are deprecated but fully supported. We now have the {{domxref('PerformanceEntry', 'Performance Entry API')}}, which provides for marking and measuring times along the navigation and resource loading process. You can also create marks:</p>

<pre class="brush: js">performance.getEntriesByType('navigation').forEach((navigation) =&gt; {
  console.dir(navigation);
});

performance.getEntriesByType('resource').forEach((resource) =&gt; {
  console.dir(resource);
});

performance.getEntriesByType('mark').forEach((mark) =&gt; {
  console.dir(mark);
});

performance.getEntriesByType("measure").forEach((measure) =&gt; {
  console.dir(measure);
});

performance.getEntriesByType('paint').forEach((paint) =&gt; {
  console.dir(paint);
});

performance.getEntriesByType('frame').forEach((frame) =&gt; {
  console.dir(frame);
});</pre>

<p>In supporting browsers, you can use <code>performance.getEntriesByType('paint')</code> to query the measure for <code>first-paint</code> and <code>first-contentful-paint</code>. We use <code>performance.getEntriesByType('navigation')</code> and<code> </code> <code>performance.getEntriesByType('resource')</code> to query the navigation and resource timings respectively.</p>

<h2 id="Navigation_Timing">Navigation Timing</h2>

<p>When a user requests a web site or application,<a href="/en-US/docs/Learn/Performance/Populating_the_page:_how_browsers_work"> to populate the browser</a> the user agent goes through a series of steps, including a {{glossary('DNS')}} lookup, {{glossary('TCP handshake')}}, and SSL negotiation, before the user agent makes the actual request and the servers return the requested assets. The browser then parses the content received, builds the DOM, CSSOM, accessibility, and render trees, eventually rendering the page. Once the user agent stops parsing the document, the user agent sets the document readiness to <em>interactive</em>. If there are deferred scripts needing to be parsed, it will do so, then fire the <a href="/en-US/docs/">DOMContentLoaded</a>, after which the readiness is set to <em>complete</em>. The Document can now handle post-load tasks, after which point the document is marked as completely loaded.</p>

<pre>let navigationTimings = performance.getEntriesByType('navigation');</pre>

<p>The <code>performance.getEntriesByType('navigation')</code>a returns an array of <a href="/en-US/docs/Web/API/PerformanceEntry">PerformanceEntry</a> objects for the <em>navigation</em> <em>type</em>.</p>

<p><img alt="The results of when performance.getEntriesByType('navigation'); is entered into the console for this document" src="https://mdn.mozillademos.org/files/16825/perfgentrybytypenavigation.png" style="height: 628px; width: 897px;"></p>

<p>A lot can be garnered from these timing. In the above image, we see via the <em>name</em> property that the file being timed is this document For the rest of this explanation, we use the following variable:</p>

<pre>let timing = performance.getEntriesByType('navigation')[0];</pre>

<h3 id="Protocol">Protocol</h3>

<p>We can check the protocol used by querying:</p>

<pre>let protocol = <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-variable">timing</span>.<span class="cm-property">nextHopProtocol</span></span></span></span></pre>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-property">It r</span></span></span></span>eturns the network protocol used to fetch the resource: in this case<span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-property"> <code>h2</code> for <code>http/2</code>.</span></span></span></span></p>

<h3 id="Compression">Compression</h3>

<p>To get the compression savings percentage, we divide the<span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"> <span class="cm-property">transferSize</span><span class="cm-property"> by the decodedBodySize</span>, and subtract that from 100%. We see a savings of over 74%.</span></span></span></p>

<pre><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-keyword">let</span> <span class="cm-def">compressionSavings</span> <span class="cm-operator">=</span> <span class="cm-number">1</span> <span class="cm-operator">-</span> (<span class="cm-variable">timing</span>.<span class="cm-property">transferSize</span> <span class="cm-operator">/</span> <span class="cm-variable">timing</span>.<span class="cm-property">decodedBodySize</span>)</span></span></span></pre>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-number">We could have used</span></span></span></span></p>

<pre><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="cm-keyword">let</span> <span class="cm-def">compressionSavings</span> <span class="cm-operator">= </span><span class="cm-number">1</span> <span class="cm-operator">-</span> (<span class="cm-variable">timing</span>.<span class="cm-property">encodedBodySize</span> <span class="cm-operator">/</span> <span class="cm-variable">timing</span>.<span class="cm-property">decodedBodySize</span>)</span></span></span></pre>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">but using <code>transfersize</code> includes the overhead bytes.</span></span></span></p>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">For comparison, we can look at the network tab and see that we transferred 22.04KB for an uncompressed file size of 87.24KB. </span></span></span></p>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><img alt="View of the bytes transferred and the size via the network tab" src="https://mdn.mozillademos.org/files/16826/bytesdownloaded.png" style="height: 107px; width: 709px;"></span></span></span></p>

<p><span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">If we do the math with these numbers, we get the same result: </span></span></span><code>1 - (22.04 / 87.24) = 0.747</code>. The navigation timings provide us a way to programmatically check transfer sizing and bandwidth savings.</p>

<p>Note that this is the size for this single document alone: for this resource alone, not for all the resources combined. However, the duration, load events and DOM related timings have to do with the entire navigation, not this single asset. Client-side web applications may seem faster than this one with <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="tree-indent tree-last-indent"></span><span class="object-label">transfer size</span><span class="object-delimiter">s under 10000 and </span><span class="object-label">decoded body size</span><span class="object-delimiter">s under </span><span class="objectBox objectBox-number">30000, but that doesn't mean JavaScript, CSS, or media assets aren't adding bloat. Checking compression ratios is important but ensure to also check duration and the time between when the DOM</span><span class="object-label">ContentLoaded event ended and when the DOM is complete, as running JavaScript on the main thread for long periods of time can lead to a non-responsive user interface.</span></span></span></span></p>

<h3 id="Request_time">Request time</h3>

<p>The API doesn't provide every measurement you may desire. For example, how long did the request take? We can use measurements we do have, to get our answer.</p>

<p>To measure the response time, subtract the request start time from the response start time. The request start is the moment immediately before the user agent starts requesting the resource from the server, or from relevant application caches or from local resources. The response start is the time immediately after the user agent's HTTP parser receives the first byte of the response from relevant application caches, or from local resources or from the server, which happens after the request is received and processed.</p>

<pre class="brush: js">request = <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/responseStart"><code>timing.responseStart</code></a> - <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/requestStart"><code>timing.requestStart</code></a></pre>

<h3 id="Load_event_duration">Load event duration</h3>

<p>By subtracting the time stamp from immediately before the load event of the current document is fired from the time when the load event of the current document is completed, you can measure the duration of the load event.</p>

<pre class="brush: js">load = <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/loadEventEnd"><code>timing.loadEventEnd</code> - <code>timing.loadEventEnd</code></a> </pre>

<h3 id="DOMContentLoaded_event">DOMContentLoaded event</h3>

<p>The DOMContentLoaded event duration is measured by subtracting the time value immediately before the user agent fires the DOMContentLoaded event from the time value immediately after the event completes. Keeping this at 50ms or faster helps ensure a responsive user interface.</p>

<pre class="brush: js">DOMContentLoaded = <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/domContentLoadedEventEnd"><code>timing.domContentLoadedEventEnd</code></a> - <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/domContentLoadedEventStart"><code>timing.domContentLoadedEventStart</code></a></pre>

<h3 id="Duration">Duration</h3>

<p>We are provided with the duration. The duration is the difference between the <a href="/en-US/docs/Web/API/PerformanceNavigationTiming/loadEventEnd">PerformanceNavigationTiming.loadEventEnd</a> and P<a href="/en-US/docs/Web/API/PerformanceEntry/startTime">erformanceEntry.startTime</a> properties.</p>

<p>The PerformanceNavigationTiming interface also provides information about what type of navigation you are measuring, returning <code>navigate</code>, <code>reload</code>, <code>back_forward</code> or <code>prerender</code>.</p>

<h2 id="Resource_timing">Resource timing</h2>

<p>Whereas navigation timing is for measuring the performance of the <em>main page</em>, generally the HTML file via which all the other assets are requested, resource timing measures timing for <em>individual resources</em>, the assets called in by the main page, and any assets that those resources request. Many of the measurements are similar: there is a DNS look up, TCP handshake and the secure connection start is done once per domain.</p>

<p><img alt="Graphic of Resource Timing timestamps" src="https://mdn.mozillademos.org/files/12093/ResourceTiming-TimeStamps.jpg"></p>

<p>The main thing to look at for each resource.</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref("PerformanceNavigationTiming")}}</li>
 <li>{{domxref("PerformanceResourceTiming")}},</li>
 <li>{{domxref("PerformanceMark")}}</li>
 <li>{{domxref("PerformanceMeasure")}}</li>
 <li>{{domxref("PerformancePaintTiming")}}</li>
</ul>
